﻿
Imports System.Runtime.InteropServices

Public Class Form1

    Private WithEvents FileOp As New FileOperation

    ' Wichtig!
    ' Vor dem Testen bitte existierende Ordner und Dateien
    ' für ScrFolderX, ScrFileX und DstFolder angeben! 

    Private ReadOnly ScrFolder0 As String = "D:\Folder0"
    Private ReadOnly ScrFolder1 As String = "D:\Folder1"
    Private ReadOnly ScrFile0 As String = "D:\File0.gif"
    Private ReadOnly ScrFile1 As String = "D:\File1.gif"
    Private ReadOnly DstFolder As String = "D:\DestFolder"

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        If FileOp IsNot Nothing Then
            FileOp.Owner = Me
            FileOp.UseOldProgressDialog = True
            If FileOp.CopyItem(ScrFolder0, DstFolder) Then
                Debug.Print("PerformOperations = " & FileOp.PerformOperations.ToString)
                Debug.Print("OperationsAborted = " & FileOp.GetOperationsAborted.ToString)
            End If
        End If
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        If FileOp IsNot Nothing Then
            FileOp.Owner = Me
            'FileOp.UseOldProgressDialog = True
            If FileOp.CopyItems(New List(Of String) From {ScrFolder0, ScrFolder1}, DstFolder) Then
                Debug.Print("PerformOperations = " & FileOp.PerformOperations.ToString)
                Debug.Print("OperationsAborted = " & FileOp.GetOperationsAborted.ToString)
            End If
        End If
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        If FileOp IsNot Nothing Then
            FileOp.Owner = Me
            'FileOp.UseOldProgressDialog = True
            If FileOp.CopyItem(ScrFolder0, DstFolder) Then
                If FileOp.CopyItem(ScrFolder1, DstFolder) Then
                    If FileOp.CopyItem(ScrFile0, DstFolder) Then
                        If FileOp.CopyItem(ScrFile1, DstFolder) Then
                            Debug.Print("PerformOperations = " & FileOp.PerformOperations.ToString)
                            Debug.Print("OperationsAborted = " & FileOp.GetOperationsAborted.ToString)
                        End If
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        If FileOp IsNot Nothing Then
            FileOp.Owner = Me
            'FileOp.UseOldProgressDialog = True
            If FileOp.CopyItems(New List(Of String) From {ScrFolder0, ScrFile1}, DstFolder) Then
                If FileOp.CopyItems(New List(Of String) From {ScrFolder1, ScrFile1}, DstFolder) Then
                    Debug.Print("PerformOperations = " & FileOp.PerformOperations.ToString)
                    Debug.Print("OperationsAborted = " & FileOp.GetOperationsAborted.ToString)
                End If
            End If
        End If
    End Sub

    Private Sub FileOp_OperationsStart() Handles FileOp.OperationsStart
        Debug.Print("StartOperations")
    End Sub

    Private Sub FileOp_OperationsFinish(Result As Integer) Handles FileOp.OperationsFinish
        Debug.Print("FinishOperations Result = " & Result.ToString)
    End Sub

    Private Sub FileOp_OperationsPreCopyItem(Flags As FileOperation.TRANSFER_SOURCE_FLAGS,
                                             pItem As IntPtr,
                                             pDestinationFolder As IntPtr,
                                             NewName As String) Handles FileOp.OperationsPreCopyItem

        'Dim strFlags As String = String.Empty

        'If Flags = FileOperation.TRANSFER_SOURCE_FLAGS.TSF_NORMAL Then
        '    strFlags &= "NORMAL,"
        'Else
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_FAIL_EXIST) Then strFlags &= "FAIL_EXIST,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_RENAME_EXIST) Then strFlags &= "RENAME_EXIST,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_OVERWRITE_EXIST) Then strFlags &= "OVERWRITE_EXIST,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_ALLOW_DECRYPTION) Then strFlags &= "ALLOW_DECRYPTION,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_NO_SECURITY) Then strFlags &= "NO_SECURITY,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_COPY_CREATION_TIME) Then strFlags &= "COPY_CREATION_TIMEL,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_COPY_WRITE_TIME) Then strFlags &= "COPY_WRITE_TIME,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_USE_FULL_ACCESS) Then strFlags &= "USE_FULL_ACCESS,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_DELETE_RECYCLE_IF_POSSIBLE) Then strFlags &= "DELETE_RECYCLE_IF_POSSIBLE,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_COPY_HARD_LINK) Then strFlags &= "COPY_HARD_LINK,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_COPY_LOCALIZED_NAME) Then strFlags &= "COPY_LOCALIZED_NAME,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_MOVE_AS_COPY_DELETE) Then strFlags &= "MOVE_AS_COPY_DELETE,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_SUSPEND_SHELLEVENTS) Then strFlags &= "SUSPEND_SHELLEVENTS,"
        'End If

        'Dim strItem As String = String.Empty
        'Dim strDest As String = String.Empty

        'If pItem <> IntPtr.Zero Then
        '    Dim IShellItem As FileOperation.IShellItem = CType(Marshal.GetObjectForIUnknown(pItem), FileOperation.IShellItem)
        '    IShellItem.GetDisplayName(FileOperation.SIGDN.SIGDN_DESKTOPABSOLUTEPARSING, strItem)
        '    Marshal.ReleaseComObject(IShellItem)
        'End If

        'If pDestinationFolder <> IntPtr.Zero Then
        '    Dim IShellItem As FileOperation.IShellItem = CType(Marshal.GetObjectForIUnknown(pDestinationFolder), FileOperation.IShellItem)
        '    IShellItem.GetDisplayName(FileOperation.SIGDN.SIGDN_DESKTOPABSOLUTEPARSING, strDest)
        '    Marshal.ReleaseComObject(IShellItem)
        'End If

        'Debug.Print("PreCopyItem Item = " & strItem &
        '            " Destination = " & strDest &
        '            " NewName = " & NewName &
        '            " Flags = " & Flags.ToString)

    End Sub

    Private Sub FileOp_OperationsPostCopyItem(Flags As FileOperation.TRANSFER_SOURCE_FLAGS,
                                              pItem As IntPtr,
                                              pDestinationFolder As IntPtr,
                                              NewName As String,
                                              CopyResult As Integer,
                                              pNewlyCreated As IntPtr) Handles FileOp.OperationsPostCopyItem

        'Dim strFlags As String = String.Empty

        'If Flags = FileOperation.TRANSFER_SOURCE_FLAGS.TSF_NORMAL Then
        '    strFlags &= "NORMAL,"
        'Else
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_FAIL_EXIST) Then strFlags &= "FAIL_EXIST,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_RENAME_EXIST) Then strFlags &= "RENAME_EXIST,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_OVERWRITE_EXIST) Then strFlags &= "OVERWRITE_EXIST,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_ALLOW_DECRYPTION) Then strFlags &= "ALLOW_DECRYPTION,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_NO_SECURITY) Then strFlags &= "NO_SECURITY,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_COPY_CREATION_TIME) Then strFlags &= "COPY_CREATION_TIMEL,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_COPY_WRITE_TIME) Then strFlags &= "COPY_WRITE_TIME,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_USE_FULL_ACCESS) Then strFlags &= "USE_FULL_ACCESS,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_DELETE_RECYCLE_IF_POSSIBLE) Then strFlags &= "DELETE_RECYCLE_IF_POSSIBLE,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_COPY_HARD_LINK) Then strFlags &= "COPY_HARD_LINK,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_COPY_LOCALIZED_NAME) Then strFlags &= "COPY_LOCALIZED_NAME,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_MOVE_AS_COPY_DELETE) Then strFlags &= "MOVE_AS_COPY_DELETE,"
        '    If CBool(Flags And FileOperation.TRANSFER_SOURCE_FLAGS.TSF_SUSPEND_SHELLEVENTS) Then strFlags &= "SUSPEND_SHELLEVENTS,"
        'End If

        'Dim strItem As String = String.Empty
        'Dim strDest As String = String.Empty
        'Dim strNewC As String = String.Empty

        'If pItem <> IntPtr.Zero Then
        '    Dim IShellItem As FileOperation.IShellItem = CType(Marshal.GetObjectForIUnknown(pItem), FileOperation.IShellItem)
        '    IShellItem.GetDisplayName(FileOperation.SIGDN.SIGDN_DESKTOPABSOLUTEPARSING, strItem)
        '    Marshal.ReleaseComObject(IShellItem)
        'End If

        'If pDestinationFolder <> IntPtr.Zero Then
        '    Dim IShellItem As FileOperation.IShellItem = CType(Marshal.GetObjectForIUnknown(pDestinationFolder), FileOperation.IShellItem)
        '    IShellItem.GetDisplayName(FileOperation.SIGDN.SIGDN_DESKTOPABSOLUTEPARSING, strDest)
        '    Marshal.ReleaseComObject(IShellItem)
        'End If

        'If pNewlyCreated <> IntPtr.Zero Then
        '    Dim IShellItem As FileOperation.IShellItem = CType(Marshal.GetObjectForIUnknown(pNewlyCreated), FileOperation.IShellItem)
        '    IShellItem.GetDisplayName(FileOperation.SIGDN.SIGDN_DESKTOPABSOLUTEPARSING, strNewC)
        '    Marshal.ReleaseComObject(IShellItem)
        'End If

        'Debug.Print("PostCopyItem: " & strItem &
        '            " Destination = " & strDest &
        '            " NewName = " & NewName &
        '            " Result = " & CopyResult.ToString &
        '            " NewlyCreated = " & strNewC &
        '            " Flags = " & Flags.ToString)

    End Sub

    Private Sub FileOp_OperationsUpdateProgress(WorkTotal As UInteger, WorkSoFar As UInteger) Handles FileOp.OperationsUpdateProgress

        'Debug.Print(WorkTotal.ToString & " / " & WorkSoFar.ToString)

    End Sub
End Class
